---
title: DataTransfer.clearData()
slug: Web/API/DataTransfer/clearData
tags:
  - API
  - DataTransfer
  - HTML DOM
  - Method
  - Reference
  - clearData
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>The <strong><code>DataTransfer.clearData()</code></strong> method removes the drag operation's {{domxref("DataTransfer","drag data")}} for the given type. If data for the given type does not exist, this method does nothing.</p>

<p class="note">If this method is called with no arguments or the format is an empty {{domxref("DOMString","string")}}, the data of all types will be removed.</p>

<p>This method does <em>not</em> remove files from the drag operation, so it's possible for there still to be an entry with the type <code>"Files"</code> left in the object's {{domxref("DataTransfer.types")}} list if there are any files included in the drag.</p>

<div class="note">
<p>This method can only be used in the handler for the {{event("dragstart")}} event, because that's the only time the drag operation's data store is writeable.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>DataTransfer</var>.clearData([<em>format</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>format</code> {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString","string")}} which specifies the type of data to remove. If this parameter is an empty string or is not provided, the data for all types is removed.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows the use of the {{domxref("DataTransfer")}} object's {{domxref("DataTransfer.getData()","getData()")}}, {{domxref("DataTransfer.setData()","setData()")}} and {{domxref("DataTransfer.clearData()","clearData()")}} methods.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;span class="tweaked" id="source" draggable="true"&gt;
  Select this element, drag it to the Drop Zone and then release the selection to move the element.
&lt;/span&gt;
&lt;span class="tweaked" id="target"&gt;Drop Zone&lt;/span&gt;
&lt;div&gt;Status: &lt;span id="status"&gt;Drag to start&lt;/span&gt;&lt;/div&gt;
&lt;div&gt;Data is: &lt;span id="data"&gt;uninitialized&lt;/span&gt;&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">span.tweaked {
  display: inline-block;
  margin: 1em 0;
  padding: 1em 2em;
}

#source {
  color: blue;
  border: 1px solid black;
}

#target {
  border: 1px solid black;
}
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">window.addEventListener('DOMContentLoaded', function () {
  // Select HTML elements
  var draggable = document.getElementById('source');
  var dropable = document.getElementById('target');
  var status = document.getElementById('status');
  var data = document.getElementById('data');
  var dropped = false;

  // Register event handlers
  draggable.addEventListener('dragstart', dragStartHandler);
  draggable.addEventListener('dragend', dragEndHandler);
  dropable.addEventListener('dragover', dragOverHandler);
  dropable.addEventListener('dragleave', dragLeaveHandler);
  dropable.addEventListener('drop', dropHandler);

  function dragStartHandler (event) {
    status.textContent = 'Drag in process';

    // Change target element's border to signify drag has started
    event.currentTarget.style.border = '1px dashed blue';

    // Start by clearing existing clipboards; this will affect all types since we
    // don't give a specific type.

    event.dataTransfer.clearData();

    // Set the drag's format and data (use event target's id for data)
    event.dataTransfer.setData('text/plain', event.target.id);

    data.textContent = event.dataTransfer.getData('text/plain');
  }

  function dragEndHandler (event) {
    if (!dropped) {
      status.textContent = 'Drag canceled';
    }

    data.textContent = event.dataTransfer.getData('text/plain') || 'empty';

    // Change border to signify drag is no longer in process
    event.currentTarget.style.border = '1px solid black';

    if (dropped) {
      // Remove all event listeners
      draggable.removeEventListener('dragstart', dragStartHandler);
      draggable.removeEventListener('dragend', dragEndHandler);
      dropable.removeEventListener('dragover', dragOverHandler);
      dropable.removeEventListener('dragleave', dragLeaveHandler);
      dropable.removeEventListener('drop', dropHandler);
    }
  }

  function dragOverHandler (event) {
    status.textContent = 'Drop available';

    event.preventDefault();
  }

  function dragLeaveHandler (event) {
    status.textContent = 'Drag in process (drop was available)';

    event.preventDefault();
  }

  function dropHandler (event) {
    dropped = true;

    status.textContent = 'Drop done';

    event.preventDefault();

    // Get data linked to event format « text »
    var _data = event.dataTransfer.getData('text/plain');
    var element = document.getElementById(_data);

    // Append drag source element to event's target element
    event.target.appendChild(element);

    // Change CSS styles and displayed text
    element.style.cssText = 'border: 1px solid black;display: block; color: red';
    element.textContent = "I'm in the Drop Zone!";
  }
})
</pre>

<p>{{EmbedLiveSample('Example', 300, 250)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'interaction.html#dom-datatransfer-cleardata','DataTransfer.clearData()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'editing.html#dom-datatransfer-cleardata','DataTransfer.clearData()')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.clearData")}}</p>

<h2 id="See_also">See also</h2>

<p>{{page("/en-US/docs/Web/API/DataTransfer", "See also")}}</p>
